import { __assign } from "tslib";
import { operationToOp } from '../../json-patch/op';
import { isRoot, isValidIndex, formatJsonPointer, isPathEqual } from '../../json-pointer';
import { lowerArrayPath } from './util';
export var xRemove = function (add, op) {
    if (isRoot(add.path))
        return null;
    if (isRoot(op.path))
        return op;
    var lastIndex = add.path.length - 1;
    var lastStep = add.path[lastIndex];
    var isLastStepNumberLike = isValidIndex(lastStep);
    if (op.op === 'remove' && isPathEqual(add.path, op.path) && isLastStepNumberLike)
        return null;
    if (isLastStepNumberLike) {
        var newPath = lowerArrayPath(add.path, op.path);
        var newFrom = op.from ? lowerArrayPath(add.path, op.from) : undefined;
        if (newPath || newFrom) {
            var operation = __assign(__assign({}, op.toJson()), { path: newPath ? formatJsonPointer(newPath) : op.path });
            if (newFrom)
                operation.from = newFrom;
            return operationToOp(operation);
        }
    }
    return op;
};
