import { __extends } from "tslib";
import { AbstractPredicateOp } from './AbstractPredicateOp';
import { find, formatJsonPointer } from '../../json-pointer';
var OpEnds = (function (_super) {
    __extends(OpEnds, _super);
    function OpEnds(path, value, ignore_case) {
        var _this = _super.call(this, 'ends', path) || this;
        _this.value = value;
        _this.ignore_case = ignore_case;
        return _this;
    }
    OpEnds.prototype.test = function (doc) {
        var val = find(doc, this.path).val;
        if (typeof val !== 'string')
            return false;
        var outer = this.ignore_case ? val.toLowerCase() : val;
        var inner = this.ignore_case ? this.value.toLowerCase() : this.value;
        var test = outer.endsWith(inner);
        return test;
    };
    OpEnds.prototype.toJson = function () {
        var op = {
            op: this.op,
            path: formatJsonPointer(this.path),
            value: this.value,
        };
        if (this.ignore_case)
            op.ignore_case = this.ignore_case;
        return op;
    };
    OpEnds.prototype.toPacked = function () {
        var packed = [32, this.path, { v: this.value }];
        if (this.ignore_case)
            packed[2].i = 1;
        return packed;
    };
    return OpEnds;
}(AbstractPredicateOp));
export { OpEnds };
