import { __extends } from "tslib";
import { AbstractOp } from './AbstractOp';
import { find, formatJsonPointer } from '../../json-pointer';
var OpFlip = (function (_super) {
    __extends(OpFlip, _super);
    function OpFlip(path) {
        return _super.call(this, 'flip', path) || this;
    }
    OpFlip.prototype.apply = function (doc) {
        var ref = find(doc, this.path);
        if (ref.obj)
            ref.obj[ref.key] = !ref.val;
        else
            doc = !ref.val;
        return { doc: doc, old: ref.val };
    };
    OpFlip.prototype.toJson = function () {
        var op = {
            op: this.op,
            path: formatJsonPointer(this.path),
        };
        return op;
    };
    OpFlip.prototype.toPacked = function () {
        var packed = [8, this.path];
        return packed;
    };
    return OpFlip;
}(AbstractOp));
export { OpFlip };
