import { __extends, __values } from "tslib";
import { find, formatJsonPointer } from '../../json-pointer';
import { AbstractPredicateOp } from './AbstractPredicateOp';
var isEqual = require('fast-deep-equal');
var OpIn = (function (_super) {
    __extends(OpIn, _super);
    function OpIn(path, value) {
        var _this = _super.call(this, 'in', path) || this;
        _this.value = value;
        return _this;
    }
    OpIn.prototype.test = function (doc) {
        var e_1, _a;
        var val = find(doc, this.path).val;
        try {
            for (var _b = __values(this.value), _c = _b.next(); !_c.done; _c = _b.next()) {
                var x = _c.value;
                if (isEqual(val, x))
                    return true;
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return false;
    };
    OpIn.prototype.toJson = function () {
        var op = {
            op: this.op,
            path: formatJsonPointer(this.path),
            value: this.value,
        };
        return op;
    };
    OpIn.prototype.toPacked = function () {
        var packed = [33, this.path, { v: this.value }];
        return packed;
    };
    return OpIn;
}(AbstractPredicateOp));
export { OpIn };
