import { __extends } from "tslib";
import { AbstractOp } from './AbstractOp';
import { find, formatJsonPointer } from '../../json-pointer';
var OpInc = (function (_super) {
    __extends(OpInc, _super);
    function OpInc(path, inc) {
        var _this = _super.call(this, 'inc', path) || this;
        _this.inc = inc;
        return _this;
    }
    OpInc.prototype.apply = function (doc) {
        var ref = find(doc, this.path);
        var result = this.inc + Number(ref.val);
        if (ref.obj)
            ref.obj[ref.key] = result;
        else
            doc = result;
        return { doc: doc, old: ref.val };
    };
    OpInc.prototype.toJson = function () {
        var op = {
            op: this.op,
            path: formatJsonPointer(this.path),
            inc: this.inc,
        };
        return op;
    };
    OpInc.prototype.toPacked = function () {
        var packed = [9, this.path, { v: this.inc }];
        return packed;
    };
    return OpInc;
}(AbstractOp));
export { OpInc };
