import { __extends } from "tslib";
import { AbstractPredicateOp } from './AbstractPredicateOp';
import { find, formatJsonPointer } from '../../json-pointer';
var OpLess = (function (_super) {
    __extends(OpLess, _super);
    function OpLess(path, value) {
        var _this = _super.call(this, 'less', path) || this;
        _this.value = value;
        return _this;
    }
    OpLess.prototype.test = function (doc) {
        var val = find(doc, this.path).val;
        if (typeof val !== 'number')
            return false;
        var test = val < this.value;
        return test;
    };
    OpLess.prototype.toJson = function () {
        var op = {
            op: this.op,
            path: formatJsonPointer(this.path),
            value: this.value,
        };
        return op;
    };
    OpLess.prototype.toPacked = function () {
        var packed = [34, this.path, { v: this.value }];
        return packed;
    };
    return OpLess;
}(AbstractPredicateOp));
export { OpLess };
