import { __extends } from "tslib";
import { AbstractOp } from './AbstractOp';
import { OpRemove } from './OpRemove';
import { OpAdd } from './OpAdd';
import { toPath, formatJsonPointer } from '../../json-pointer';
var OpMove = (function (_super) {
    __extends(OpMove, _super);
    function OpMove(path, from) {
        var _this = _super.call(this, 'move', path) || this;
        _this.from = from;
        return _this;
    }
    OpMove.prototype.apply = function (doc) {
        var remove = new OpRemove(toPath(this.from), undefined).apply(doc);
        var add = new OpAdd(this.path, remove.old).apply(remove.doc);
        return add;
    };
    OpMove.prototype.toJson = function () {
        return {
            op: this.op,
            path: formatJsonPointer(this.path),
            from: formatJsonPointer(this.from),
        };
    };
    OpMove.prototype.toPacked = function () {
        var packed = [4, this.path, { f: this.from }];
        return packed;
    };
    return OpMove;
}(AbstractOp));
export { OpMove };
