import { __extends, __values } from "tslib";
import { AbstractSecondOrderPredicateOp } from './AbstractSecondOrderPredicateOp';
import { formatJsonPointer } from '../../json-pointer';
var OpNot = (function (_super) {
    __extends(OpNot, _super);
    function OpNot(path, ops) {
        var _this = _super.call(this, 'not', path, ops) || this;
        _this.ops = ops;
        return _this;
    }
    OpNot.prototype.test = function (doc) {
        var e_1, _a;
        try {
            for (var _b = __values(this.ops), _c = _b.next(); !_c.done; _c = _b.next()) {
                var op = _c.value;
                if (op.test(doc))
                    return false;
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return true;
    };
    OpNot.prototype.toJson = function () {
        var op = {
            op: this.op,
            path: formatJsonPointer(this.path),
            apply: this.ops.map(function (op) { return op.toJson(); }),
        };
        return op;
    };
    OpNot.prototype.toPacked = function () {
        var packed = [44, this.path, { o: this.ops.map(function (op) { return op.toPacked(); }) }];
        return packed;
    };
    return OpNot;
}(AbstractSecondOrderPredicateOp));
export { OpNot };
