import { __extends } from "tslib";
import { AbstractPredicateOp } from './AbstractPredicateOp';
import { find, formatJsonPointer } from '../../json-pointer';
var isArray = Array.isArray;
var OpTestType = (function (_super) {
    __extends(OpTestType, _super);
    function OpTestType(path, type) {
        var _this = _super.call(this, 'test_type', path) || this;
        _this.type = type;
        return _this;
    }
    OpTestType.prototype.test = function (doc) {
        var val = find(doc, this.path).val;
        if (val === null)
            return this.type.indexOf('null') > -1;
        if (isArray(val))
            return this.type.indexOf('array') > -1;
        if (this.type.indexOf(typeof val) > -1)
            return true;
        if (typeof val === 'number' && val === Math.round(val) && this.type.indexOf('integer') > -1)
            return true;
        return false;
    };
    OpTestType.prototype.toJson = function () {
        var op = {
            op: this.op,
            path: formatJsonPointer(this.path),
            type: this.type,
        };
        return op;
    };
    OpTestType.prototype.toPacked = function () {
        var packed = [39, this.path, { t: this.type }];
        return packed;
    };
    return OpTestType;
}(AbstractPredicateOp));
export { OpTestType };
