import { __extends } from "tslib";
import { AbstractPredicateOp } from './AbstractPredicateOp';
import { find, formatJsonPointer } from '../../json-pointer';
var isArray = Array.isArray;
var OpType = (function (_super) {
    __extends(OpType, _super);
    function OpType(path, value) {
        var _this = _super.call(this, 'type', path) || this;
        _this.value = value;
        return _this;
    }
    OpType.prototype.test = function (doc) {
        var val = find(doc, this.path).val;
        if (val === null)
            return this.value === 'null';
        if (isArray(val))
            return this.value === 'array';
        if (typeof val === this.value)
            return true;
        if (typeof val === 'number' && val === Math.round(val) && this.value === 'integer')
            return true;
        return false;
    };
    OpType.prototype.toJson = function () {
        var op = {
            op: this.op,
            path: formatJsonPointer(this.path),
            value: this.value,
        };
        return op;
    };
    OpType.prototype.toPacked = function () {
        var packed = [42, this.path, { v: this.value }];
        return packed;
    };
    return OpType;
}(AbstractPredicateOp));
export { OpType };
