import { __extends } from "tslib";
import { AbstractPredicateOp } from './AbstractPredicateOp';
import { find, formatJsonPointer } from '../../json-pointer';
var OpUndefined = (function (_super) {
    __extends(OpUndefined, _super);
    function OpUndefined(path) {
        return _super.call(this, 'undefined', path) || this;
    }
    OpUndefined.prototype.test = function (doc) {
        try {
            var val = find(doc, this.path).val;
            var test_1 = val === undefined;
            return test_1;
        }
        catch (error) {
            if (error.message === 'NOT_FOUND')
                return true;
            throw error;
        }
    };
    OpUndefined.prototype.toJson = function () {
        var op = {
            op: this.op,
            path: formatJsonPointer(this.path),
        };
        return op;
    };
    OpUndefined.prototype.toPacked = function () {
        var packed = [38, this.path];
        return packed;
    };
    return OpUndefined;
}(AbstractPredicateOp));
export { OpUndefined };
