import { __awaiter, __generator, __read } from "tslib";
import { assertId, assertName, isArray } from './util';
var JsonRpcRxServer = (function () {
    function JsonRpcRxServer(_a) {
        var call = _a.call, notify = _a.notify;
        this.call = call;
        this.notify = notify;
    }
    JsonRpcRxServer.prototype.onSubscribe = function (ctx, message) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, id, name, payload, result;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = __read(message, 3), id = _a[0], name = _a[1], payload = _a[2];
                        assertId(id);
                        assertName(name);
                        return [4, this.call(name, ctx, payload)];
                    case 1:
                        result = _b.sent();
                        return [2, [0, id, result]];
                }
            });
        });
    };
    JsonRpcRxServer.prototype.onNotification = function (ctx, message) {
        var _a = __read(message, 2), name = _a[0], payload = _a[1];
        assertName(name);
        this.notify(name, ctx, payload);
    };
    JsonRpcRxServer.prototype.onMessage = function (ctx, message) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, one, error_1, id;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _b.trys.push([0, 3, , 4]);
                        if (!isArray(message))
                            throw new Error('Invalid message');
                        _a = __read(message, 1), one = _a[0];
                        if (typeof one === 'string') {
                            this.onNotification(ctx, message);
                            return [2, null];
                        }
                        if (!(one > 0)) return [3, 2];
                        return [4, this.onSubscribe(ctx, message)];
                    case 1: return [2, _b.sent()];
                    case 2: throw new Error('Invalid message');
                    case 3:
                        error_1 = _b.sent();
                        id = isArray(message) && (typeof message[0] === 'number') && (message[0] > 0) && (Math.round(message[0]) === message[0])
                            ? message[0] : -1;
                        return [2, [-1, id, { message: error_1 instanceof Error ? error_1.message : String(error_1) }]];
                    case 4: return [2];
                }
            });
        });
    };
    return JsonRpcRxServer;
}());
export { JsonRpcRxServer };
