import { __assign } from "tslib";
import { operationToOp } from '../../json-patch/op';
import { isRoot, isValidIndex, isChild, formatJsonPointer } from '../../json-pointer';
import { bumpArrayPath } from './util';
export var xAdd = function (add, op) {
    if (isRoot(add.path))
        return null;
    if (isRoot(op.path))
        return op;
    var lastIndex = add.path.length - 1;
    var lastStep = add.path[lastIndex];
    var isLastStepNumberLike = isValidIndex(lastStep);
    if (isChild(add.path, op.path) && !isLastStepNumberLike)
        return null;
    if (isLastStepNumberLike) {
        var newPath = bumpArrayPath(add.path, op.path);
        var newFrom = op.from ? bumpArrayPath(add.path, op.from) : undefined;
        if (newPath || newFrom) {
            var operation = __assign(__assign({}, op.toJson()), { path: newPath ? formatJsonPointer(newPath) : op.path });
            if (newFrom)
                operation.from = formatJsonPointer(newFrom);
            return operationToOp(operation);
        }
    }
    return op;
};
