import { __extends } from "tslib";
import { AbstractOp } from './AbstractOp';
import { find, formatJsonPointer } from '../../json-pointer';
import { OpAdd } from './OpAdd';
import { deepClone } from '../util';
var OpCopy = (function (_super) {
    __extends(OpCopy, _super);
    function OpCopy(path, from) {
        var _this = _super.call(this, 'copy', path) || this;
        _this.from = from;
        return _this;
    }
    OpCopy.prototype.apply = function (doc) {
        var val = find(doc, this.from).val;
        if (val === undefined)
            throw new Error('NOT_FOUND');
        var add = new OpAdd(this.path, deepClone(val)).apply(doc);
        return add;
    };
    OpCopy.prototype.toJson = function () {
        return {
            op: this.op,
            path: formatJsonPointer(this.path),
            from: formatJsonPointer(this.from),
        };
    };
    OpCopy.prototype.toPacked = function () {
        var packed = [3, this.path, { f: this.from }];
        return packed;
    };
    return OpCopy;
}(AbstractOp));
export { OpCopy };
