import { __extends } from "tslib";
import { AbstractPredicateOp } from './AbstractPredicateOp';
import { find, formatJsonPointer } from '../../json-pointer';
var OpMore = (function (_super) {
    __extends(OpMore, _super);
    function OpMore(path, value) {
        var _this = _super.call(this, 'more', path) || this;
        _this.value = value;
        return _this;
    }
    OpMore.prototype.test = function (doc) {
        var val = find(doc, this.path).val;
        if (typeof val !== 'number')
            return false;
        var test = val > this.value;
        return test;
    };
    OpMore.prototype.toJson = function () {
        var op = {
            op: this.op,
            path: formatJsonPointer(this.path),
            value: this.value,
        };
        return op;
    };
    OpMore.prototype.toPacked = function () {
        var packed = [36, this.path, { v: this.value }];
        return packed;
    };
    return OpMore;
}(AbstractPredicateOp));
export { OpMore };
