import { __extends } from "tslib";
import { AbstractOp } from './AbstractOp';
import { find, isObjectReference, isArrayReference, formatJsonPointer } from '../../json-pointer';
var OpReplace = (function (_super) {
    __extends(OpReplace, _super);
    function OpReplace(path, value, oldValue) {
        var _this = _super.call(this, 'replace', path) || this;
        _this.value = value;
        _this.oldValue = oldValue;
        return _this;
    }
    OpReplace.prototype.apply = function (doc) {
        var ref = find(doc, this.path);
        if (ref.val === undefined)
            throw new Error('NOT_FOUND');
        if (isObjectReference(ref))
            ref.obj[ref.key] = this.value;
        else if (isArrayReference(ref))
            ref.obj[ref.key] = this.value;
        else
            doc = this.value;
        return { doc: doc, old: ref.val };
    };
    OpReplace.prototype.toJson = function () {
        var json = {
            op: this.op,
            path: formatJsonPointer(this.path),
            value: this.value,
        };
        if (this.oldValue !== undefined)
            json.oldValue = this.oldValue;
        return json;
    };
    OpReplace.prototype.toPacked = function () {
        var packed = [2, this.path, { v: this.value }];
        if (this.oldValue !== undefined)
            packed[2].o = this.oldValue;
        return packed;
    };
    return OpReplace;
}(AbstractOp));
export { OpReplace };
