import { __extends } from "tslib";
import { AbstractOp } from './AbstractOp';
import { find, formatJsonPointer } from '../../json-pointer';
var OpStrIns = (function (_super) {
    __extends(OpStrIns, _super);
    function OpStrIns(path, pos, str) {
        var _this = _super.call(this, 'str_ins', path) || this;
        _this.pos = pos;
        _this.str = str;
        return _this;
    }
    OpStrIns.prototype.apply = function (doc) {
        var _a = find(doc, this.path), val = _a.val, key = _a.key, obj = _a.obj;
        if (typeof val !== 'string') {
            if (val !== undefined)
                throw new Error('NOT_A_STRING');
            if (this.pos !== 0)
                throw new Error('POS');
        }
        var str = typeof val === 'string' ? val : '';
        var pos = Math.min(this.pos, str.length);
        var before = str.slice(0, pos);
        var after = str.slice(pos);
        var result = before + this.str + after;
        if (obj)
            obj[key] = result;
        else
            doc = result;
        return { doc: doc, old: val };
    };
    OpStrIns.prototype.toJson = function () {
        var op = {
            op: this.op,
            path: formatJsonPointer(this.path),
            pos: this.pos,
            str: this.str,
        };
        return op;
    };
    OpStrIns.prototype.toPacked = function () {
        var packed = [6, this.path, { i: this.pos, s: this.str }];
        return packed;
    };
    return OpStrIns;
}(AbstractOp));
export { OpStrIns };
