import { __extends } from "tslib";
import { find, formatJsonPointer } from '../../json-pointer';
import { AbstractPredicateOp } from './AbstractPredicateOp';
var isEqual = require('fast-deep-equal');
var OpTest = (function (_super) {
    __extends(OpTest, _super);
    function OpTest(path, value, not) {
        var _this = _super.call(this, 'test', path) || this;
        _this.value = value;
        _this.not = not;
        return _this;
    }
    OpTest.prototype.test = function (doc) {
        var val = find(doc, this.path).val;
        if (val === undefined)
            return !!this.not;
        var test = isEqual(val, this.value);
        return this.not ? !test : test;
    };
    OpTest.prototype.toJson = function () {
        var op = {
            op: this.op,
            path: formatJsonPointer(this.path),
            value: this.value,
        };
        if (this.not)
            op.not = this.not;
        return op;
    };
    OpTest.prototype.toPacked = function () {
        var packed = [5, this.path, { v: this.value }];
        if (this.not)
            packed[2].n = 1;
        return packed;
    };
    return OpTest;
}(AbstractPredicateOp));
export { OpTest };
