import { __extends } from "tslib";
import { AbstractPredicateOp } from './AbstractPredicateOp';
import { find, formatJsonPointer } from '../../json-pointer';
var OpTestString = (function (_super) {
    __extends(OpTestString, _super);
    function OpTestString(path, pos, str, not) {
        var _this = _super.call(this, 'test_string', path) || this;
        _this.pos = pos;
        _this.str = str;
        _this.not = not;
        return _this;
    }
    OpTestString.prototype.test = function (doc) {
        var val = find(doc, this.path).val;
        if (typeof val !== 'string')
            return false;
        var length = val.length;
        var start = Math.min(this.pos, length);
        var end = Math.min(this.pos + this.str.length, length);
        var test = val.substring(start, end) === this.str;
        return this.not ? !test : test;
    };
    OpTestString.prototype.toJson = function () {
        var op = {
            op: this.op,
            path: formatJsonPointer(this.path),
            pos: this.pos,
            str: this.str,
        };
        if (this.not)
            op.not = this.not;
        return op;
    };
    OpTestString.prototype.toPacked = function () {
        var packed = [40, this.path, { i: this.pos, s: this.str }];
        if (this.not)
            packed[2].n = 1;
        return packed;
    };
    return OpTestString;
}(AbstractPredicateOp));
export { OpTestString };
