import { __extends } from "tslib";
import { AbstractPredicateOp } from './AbstractPredicateOp';
import { find, formatJsonPointer } from '../../json-pointer';
var OpTestStringLen = (function (_super) {
    __extends(OpTestStringLen, _super);
    function OpTestStringLen(path, len, not) {
        var _this = _super.call(this, 'test_string_len', path) || this;
        _this.len = len;
        _this.not = not;
        return _this;
    }
    OpTestStringLen.prototype.test = function (doc) {
        var val = find(doc, this.path).val;
        if (typeof val !== 'string')
            return false;
        var length = val.length;
        var test = val.length >= this.len;
        return this.not ? !test : test;
    };
    OpTestStringLen.prototype.toJson = function () {
        var op = {
            op: this.op,
            path: formatJsonPointer(this.path),
            len: this.len,
        };
        if (this.not)
            op.not = this.not;
        return op;
    };
    OpTestStringLen.prototype.toPacked = function () {
        var packed = [41, this.path, { l: this.len }];
        if (this.not)
            packed[2].n = 1;
        return packed;
    };
    return OpTestStringLen;
}(AbstractPredicateOp));
export { OpTestStringLen };
