import { __values } from "tslib";
import { deepClone } from './util';
import { operationToOp } from './op';
export function applyOp(doc, op, mutate) {
    if (!mutate)
        doc = deepClone(doc);
    return op.apply(doc);
}
export function applyOps(doc, ops, mutate) {
    var e_1, _a;
    if (!Array.isArray(ops))
        throw new Error('SEQUENCE_NOT_AN_ARRAY');
    if (!mutate)
        doc = deepClone(doc);
    var res = [];
    try {
        for (var ops_1 = __values(ops), ops_1_1 = ops_1.next(); !ops_1_1.done; ops_1_1 = ops_1.next()) {
            var op = ops_1_1.value;
            var opResult = op.apply(doc);
            doc = opResult.doc;
            res.push(opResult);
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (ops_1_1 && !ops_1_1.done && (_a = ops_1.return)) _a.call(ops_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    return { doc: doc, res: res };
}
export function applyPatch(doc, patch, mutate) {
    var result = applyOps(doc, patch.map(operationToOp), mutate);
    return result;
}
