import { isRoot, isValidIndex, hasOwnProperty } from './util';
var isArray = Array.isArray;
export var find = function (val, path, skipLast) {
    if (skipLast === void 0) { skipLast = 0; }
    if (isRoot(path))
        return { val: val };
    var obj;
    var key;
    var last = path.length - 1 - skipLast;
    for (var i = 0; i <= last; i++) {
        var component = path[i];
        obj = val;
        key = component;
        if (isArray(obj)) {
            if (key === '-' && i === path.length - 1)
                key = obj.length;
            else {
                if (!isValidIndex(key))
                    throw new Error('INVALID_INDEX');
                key = Number(key);
                if (key < 0)
                    throw new Error('INVALID_INDEX');
            }
            val = hasOwnProperty(obj, String(key)) ? obj[key] : undefined;
        }
        else if (typeof obj === 'object' && !!obj) {
            val = hasOwnProperty(obj, String(key)) ? obj[key] : undefined;
        }
        else
            throw new Error('NOT_FOUND');
    }
    var ref = { val: val, obj: obj, key: key };
    return ref;
};
export var isArrayReference = function (ref) {
    return isArray(ref.obj) && typeof ref.key === 'number';
};
export var isArrayEnd = function (ref) { return ref.obj.length === ref.key; };
export var isObjectReference = function (ref) {
    return typeof ref.obj === 'object' && typeof ref.key === 'string';
};
